﻿using System.ComponentModel;

namespace TestProject
{
    /// <summary>
    /// 사람
    /// </summary>
    public class Person : IDataErrorInfo
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 나이 - Age

        /// <summary>
        /// 나이
        /// </summary>
        public int Age { get; set; }

        #endregion
        #region 에러 - Error

        /// <summary>
        /// 에러
        /// </summary>
        public string Error => null;

        #endregion
        #region 인덱서 - this[name]

        /// <summary>
        /// 인덱서
        /// </summary>
        /// <param name="name">명칭</param>
        /// <returns>오류 메시지</returns>
        public string this[string name]
        {
            get
            {
                string result = null;

                if(name == "Age")
                {
                    if(Age < 0 || Age > 150)
                    {
                        result = "Age must not be less than 0 or greater than 150.";
                    }
                }

                return result;
            }
        }

        #endregion
    }
}